
Foreman - Bug #2431

Foreman MYSQL Error on hosts_and_Facts import when FQDN is missing

04/25/2013 06:53 PM - Sam McLeod

Status: Closed   

Priority: Normal   

Assignee:    

Category: Facts   

Target version: 1.3.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

hostnames removed for privacy's sake.

root@puppetmaster:~# rake -f /usr/share/foreman/Rakefile puppet:import:hosts_and_facts RAILS_ENV=p

roduction

Libvirt binding are missing - hypervisor management is disabled

Importing from /var/lib/puppet/yaml/facts

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved.net.au

Importing nameremoved

rake aborted!

Mysql::Error: Column 'name' cannot be null: INSERT INTO `hosts` (`model_id`, `serial`, `ip`, `loca

tion_id`, `certname`, `root_pass`, `build`, `enabled`, `mac`, `managed`, `updated_at`, `puppet_pro

xy_id`, `subnet_id`, `image_id`, `organization_id`, `last_freshcheck`, `use_image`, `domain_id`, `

puppet_ca_proxy_id`, `name`, `disk`, `source_file_id`, `comment`, `operatingsystem_id`, `last_comp

ile`, `owner_type`, `environment_id`, `medium_id`, `compute_resource_id`, `architecture_id`, `owne

r_id`, `image_file`, `puppet_status`, `installed_at`, `environment`, `ptable_id`, `hostgroup_id`, 

`uuid`, `created_at`, `last_report`) VALUES (NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, '', NULL, '

2013-04-25 22:46:37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL

, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, '2013-04-25 22:

46:37', NULL)

Tasks: TOP => puppet:import:hosts_and_facts

(See full trace by running task with --trace)

 
root@puppetmaster:~# dpkg --list | grep foreman

ii  foreman                                    1.1.1+debian1                Systems management web

 interface

rc  foreman-mysql                              1.1.1+debian1                metapackage providing 

MySQL dependencies for Foreman

ii  foreman-proxy                              1.1+debian1                  RESTful proxies for DN

S, DHCP, TFTP, and Puppet

root@puppetmaster:~# dpkg --list | grep puppet

ii  facter                                     1.6.18-1puppetlabs1          Ruby module for collec

ting simple facts about a host operating system

ii  hiera                                      1.1.2-1puppetlabs1           A simple pluggable Hie

rarchical Database.

ii  puppet                                     2.6.2-5+squeeze7             Centralized configurat

ion management - agent startup and compatibility scripts

ii  puppet-common                              2.6.2-5+squeeze7             Centralized configurat
ion management

iF  puppet-dashboard                           1.2.23-1puppetlabs1          Dashboard for Puppet

ii  puppetlabs-release                         1.0-5                        "Package to install Pu

ppet Labs gpg key and apt repo" 

ii  puppetmaster                               2.6.2-5+squeeze7             Centralized configurat

ion management - master startup and compatibility scripts

 
root@puppetmaster:~# cat /etc/debian_version 

6.0.7

root@puppetmaster:~# uname -a

Linux puppetmaster 3.2.0-0.bpo.4-686-pae #1 SMP Debian 3.2.35-2~bpo60+1 i686 GNU/Linux

root@puppetmaster:~# rails --version

Rails 2.3.5

root@puppetmaster:~# ruby --version

ruby 1.8.7 (2010-08-16 patchlevel 302) [i486-linux]

 I've tried looking through /var/lib/puppet/yaml/facts/* to see if I can find any yaml's with dodgy characters etc... but I can't see

anything.

I believe this happened after upgrading foreman, but we only noticed the cron job failing a few days ago so I can't be certain.

Related issues:

Has duplicate Foreman - Bug #3154: Failed to import facts: undefined method `... Duplicate 09/27/2013

Associated revisions

Revision 3d6c46e5 - 08/21/2013 10:45 AM - Ash Caire 

fixes #2431 - handle fact uploads where host is missing $fqdn

History

#1 - 04/25/2013 07:07 PM - Sam McLeod

OK we just fixed it - we removed all hosts that didn't have a FQDN, we found that once this was done there were actually duplicates of those hosts

that existed with the FQDN.

Can close this one off.

#2 - 04/26/2013 03:35 AM - Dominic Cleal

- Status changed from New to Closed

Thanks for finding the cause Sam!

#3 - 04/29/2013 12:13 AM - Sam McLeod

Hi,

I actually need this ticket re-opened.

Although deleting the hosts that the rake complains about worked, as soon as those hosts did their next puppet run forman's rake complained about

those same hosts again.

I ran the yaml files for those hosts through several yaml syntax checkers and looked them over from top to bottom but I can't see any issues?

#4 - 04/30/2013 03:23 AM - Dominic Cleal

- Status changed from Closed to Feedback

Do your host have an "fqdn" fact?  The resolution of this changed in Facter 1.7.0 to use `hostname -f` which has broken a few (perhaps

misconfigured) installations.

#5 - 05/01/2013 06:48 PM - Sam McLeod

Dominic Cleal wrote:

Do your host have an "fqdn" fact?  The resolution of this changed in Facter 1.7.0 to use `hostname -f` which has broken a few (perhaps

misconfigured) installations.

 Hi Dominic,

Thanks for pointing us in the right direction.
The hosts were unaware of the fqdn's - they didn't have the fact at all.

We fixed this by added the fqdn to /etc/hosts on the 127.0.1.1 line.

This caused the fqdn fact to be created and then properly handed the information to foreman.

I'm not sure if this is a common issue but it may be other adding some more description error information to the rake task as to why it fails.

#6 - 05/02/2013 03:28 AM - Dominic Cleal

- Subject changed from Foreman MYSQL Error on hosts_and_Facts import to Foreman MYSQL Error on hosts_and_Facts import when FQDN is

missing

- Category set to Facts

- Status changed from Feedback to New

#7 - 08/21/2013 08:12 AM - Dominic Cleal

- Description updated

- Status changed from New to Ready For Testing

- Target version set to 1.3.0

This PR from Ash Caire makes Foreman fall back to the certname if the FQDN's missing, which I'm pretty sure will fix the rake task too as they share

a code path.

https://github.com/theforeman/foreman/pull/836

#8 - 08/21/2013 11:31 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 3d6c46e5132ab60b3ad791a43f94b9fefd9e23e2.

#9 - 09/27/2013 07:38 AM - Dominic Cleal

- Has duplicate Bug #3154: Failed to import facts: undefined method `downcase' for nil:NilClass added
